diff --git a/interface/scan_devices.c b/interface/scan_devices.c
index fc58110..07f928b 100644
--- a/interface/scan_devices.c
+++ b/interface/scan_devices.c
@@ -67,21 +67,20 @@ cdrom_drive *cdda_find_a_cdrom(int messagedest,char **messages){
     /* is it a name or a pattern? */
     char *pos;
     if((pos=strchr(cdrom_devices[i],'?'))){
+      const char suffixes[] = "0a1b2c3d";
       int j;
-      /* try first eight of each device */
-      for(j=0;j<4;j++){
+      /* try each suffix for each device pattern */
+      for(j=0;suffixes[j];j++){
 	char *buffer=copystring(cdrom_devices[i]);
 
 	/* number, then letter */
 	
-	buffer[pos-(cdrom_devices[i])]=j+48;
-	if((d=cdda_identify(buffer,messagedest,messages)))
-	  return(d);
-	idmessage(messagedest,messages,"",NULL);
-	buffer[pos-(cdrom_devices[i])]=j+97;
+	buffer[pos-(cdrom_devices[i])]=suffixes[j];
 	if((d=cdda_identify(buffer,messagedest,messages)))
 	  return(d);
 	idmessage(messagedest,messages,"",NULL);
+
+	free(buffer);
       }
     }else{
       /* Name.  Go for it. */